<?php

use Bitrix\Main\Loader;
use Bitrix\Main\LoaderException;

const BB_MODULE_ID = 'boxberry.delivery';

$classesArray = [
    'Sale\Handlers\Delivery\BoxberryHandler' => 'handler.php',
    'Sale\Handlers\Delivery\BoxberryProfile' => 'profile.php',
    'Boxberry\Api\Client' => 'lib/boxberry/api/Client.php',
    'Boxberry\Api\Entity\WidgetSettings' => 'lib/boxberry/api/entity/WidgetSettings.php',
    'Boxberry\Api\Entity\ZipCheck' => 'lib/boxberry/api/entity/ZipCheck.php',
    'Boxberry\Api\Entity\GetKeyIntegration' => 'lib/boxberry/api/entity/GetKeyIntegration.php',
    'Boxberry\Api\Entity\GetLastStatusData' => 'lib/boxberry/api/entity/GetLastStatusData.php',
    'Boxberry\Api\Entity\ParcelParams' => 'lib/boxberry/api/entity/ParcelParams.php',
    'Boxberry\Api\Entity\ParcelResult' => 'lib/boxberry/api/entity/ParcelResult.php',
    'Boxberry\Api\Entity\Kurdost' => 'lib/boxberry/api/entity/Kurdost.php',
    'Boxberry\Api\Entity\Export' => 'lib/boxberry/api/entity/Export.php',
    'Boxberry\Api\Entity\Shop' => 'lib/boxberry/api/entity/Shop.php',
    'Boxberry\Api\Entity\Customer' => 'lib/boxberry/api/entity/Customer.php',
    'Boxberry\Api\Entity\ParselSendResult' => 'lib/boxberry/api/entity/ParselSendResult.php',
    'Boxberry\Api\Entity\ParcelInfoResult' => 'lib/boxberry/api/entity/ParcelInfoResult.php',
    'Boxberry\Api\Entity\DeliveryCalculationParams' => 'lib/boxberry/api/entity/DeliveryCalculationParams.php',
    'Boxberry\Api\Entity\DeliveryCalculationResult' => 'lib/boxberry/api/entity/DeliveryCalculationResult.php',
    'Boxberry\Api\Entity\PointsDescriptionResult' => 'lib/boxberry/api/entity/PointsDescriptionResult.php',
    'Boxberry\Api\Entity\DadataResult' => 'lib/boxberry/api/entity/DadataResult.php',
    'Boxberry\Api\Exceptions\BoxberryApiException' => 'lib/boxberry/api/exceptions/BoxberryApiException.php',
    'Boxberry\Bitrix\OrdersTable' => 'lib/boxberry/bitrix/OrdersTable.php',
    'Boxberry\Bitrix\CitiesFullTable' => 'lib/boxberry/bitrix/CitiesFullTable.php',
    'Boxberry\Bitrix\PointsForParcelsTable' => 'lib/boxberry/bitrix/PointsForParcelsTable.php',
    'Boxberry\Bitrix\Helpers\Options' => 'lib/boxberry/bitrix/helpers/Options.php',
    'Boxberry\Bitrix\Helpers\Delivery' => 'lib/boxberry/bitrix/helpers/Delivery.php',
    'Boxberry\Bitrix\Helpers\Widget' => 'lib/boxberry/bitrix/helpers/Widget.php',
    'Boxberry\Bitrix\Helpers\Validator' => 'lib/boxberry/bitrix/helpers/Validator.php',
    'Boxberry\Bitrix\Helpers\Logger' => 'lib/boxberry/bitrix/helpers/Logger.php',
    'Boxberry\Bitrix\Helpers\Extensions' => 'lib/boxberry/bitrix/helpers/Extensions.php',
    'Boxberry\Bitrix\Forms\OrderForm' => 'lib/boxberry/bitrix/forms/OrderForm.php',
    'Boxberry\Bitrix\Handlers\Order' => 'lib/boxberry/bitrix/handlers/Order.php',
    'Boxberry\Bitrix\Entity\OrderData' => 'lib/boxberry/bitrix/entity/OrderData.php',
    'Boxberry\Bitrix\Entity\Order' => 'lib/boxberry/bitrix/entity/Order.php',
    'Boxberry\Bitrix\Entity\City' => 'lib/boxberry/bitrix/entity/City.php',
    'Boxberry\Bitrix\Entity\ProductItem' => 'lib/boxberry/bitrix/entity/ProductItem.php',
    'Boxberry\Bitrix\Helpers\BoxSizes' => 'lib/boxberry/bitrix/helpers/BoxSizes.php',
    'Boxberry\Bitrix\Helpers\BoxSizesCalculator' => 'lib/boxberry/bitrix/helpers/BoxSizesCalculator.php',
    'Boxberry\Api\CountriesSettings' => 'lib/boxberry/api/CountriesSettings.php',
    'Boxberry\Bitrix\Agents\Tracking' => 'lib/boxberry/bitrix/agents/Tracking.php',
    'Boxberry\Bitrix\Agents\KeysChecker' => 'lib/boxberry/bitrix/agents/KeysChecker.php',
    'Boxberry\Bitrix\Agents\CitiesUpdate' => 'lib/boxberry/bitrix/agents/CitiesUpdate.php',
    'Boxberry\Bitrix\Agents\PointsForParcelsUpdate' => 'lib/boxberry/bitrix/agents/PointsForParcelsUpdate.php',
    'Boxberry\Bitrix\Agents\BaseAgent' => 'lib/boxberry/bitrix/agents/BaseAgent.php',
    'Boxberry\Delivery\ActionFilter\Referer' => 'lib/actionfilter/Referer.php',
    'Boxberry\Bitrix\Services\Updater' => 'lib/boxberry/bitrix/services/Updater.php'
];

try {
    Loader::includeModule('sale');
    Loader::registerAutoLoadClasses(
        BB_MODULE_ID,
        $classesArray,
    );
} catch (LoaderException $e) {
}

Loader::autoLoad('Sale\Handlers\Delivery\BoxberryHandler');
Loader::autoLoad('Sale\Handlers\Delivery\BoxberryProfile');
