<?php

use Bitrix\Main\Event;
use Bitrix\Main\EventManager;
use Bitrix\Main\EventResult;
use Boxberry\Bitrix\Handlers\Order;
use Boxberry\Bitrix\Helpers\Extensions;
use Boxberry\Bitrix\Helpers\Options;

require_once($_SERVER['DOCUMENT_ROOT'] . '/bitrix/modules/boxberry.delivery/include.php');

$eventManager = EventManager::getInstance();
$eventManager->addEventHandler('sale', 'onSaleDeliveryHandlersClassNamesBuildList', 'addBoxberryDeliveryServices');
$eventManager->addEventHandler('sale', 'OnSaleOrderBeforeSaved', 'bbOnSaleOrderBeforeSaved');
$eventManager->addEventHandler('sale', 'OnSaleOrderSaved', 'bbOnSaleOrderSaved');
$eventManager->addEventHandler('sale', 'OnSaleStatusOrderChange', 'bbOnSaleStatusOrderChange');
$eventManager->addEventHandler('sale', 'OnSaleComponentOrderJsData', 'bbOnSaleComponentOrderJsData');
$eventManager->addEventHandler('sale', 'onSaleAdminOrderInfoBlockShow', 'bbOnSaleAdminOrderInfoBlockShow');

if (Options::isEnabledInitWidgetOnlyOnStandardEvent()) {
    $eventManager->addEventHandler('sale', 'OnSaleComponentOrderOneStepDelivery', 'bbOnSaleComponentOrderOneStepDelivery');
} else {
    Extensions::initWidget();
}

function addBoxberryDeliveryServices(Event $event): EventResult
{
    return new EventResult(
        EventResult::SUCCESS,
        [
            '\Sale\Handlers\Delivery\BoxberryHandler' => '/bitrix/modules/' . BB_MODULE_ID . '/handler.php',
            '\Sale\Handlers\Delivery\BoxberryProfile' => '/bitrix/modules/' . BB_MODULE_ID . '/profile.php',
        ],
        BB_MODULE_ID
    );
}

function bbOnSaleOrderBeforeSaved(Event $event): EventResult
{
    return Order::checkOrderBeforeSaved($event);
}

function bbOnSaleOrderSaved(Event $event): void
{
    Order::createBbOrderOnSaveEvent($event);
}

function bbOnSaleStatusOrderChange(Event $event): void
{
    Order::createBbOrderOnBitrixStatusChange($event);
}

function bbOnSaleAdminOrderInfoBlockShow(Event $event): EventResult
{
    return Order::addBbOrderInfoBlock($event);
}

function bbOnSaleComponentOrderJsData(&$arResult, &$arParams): void
{
    Order::addBbOrderJsData($arResult, $arParams);
}

function bbOnSaleComponentOrderOneStepDelivery(&$arResult, &$arParams): void
{
    Extensions::initWidget();
}