function handleDatalist(input) {
    const dataList = document.createElement('datalist');
    dataList.id = 'names-datalist';
    input.setAttribute('list', 'names-datalist');
    input.parentNode.appendChild(dataList);

    input.addEventListener('input', function () {
        const searchTerm = this.value;
        dataList.innerHTML = '';

        if (searchTerm.length >= 2) {
            fetch('/bitrix/services/main/ajax.php?action=boxberry:delivery.api.service.getPointsForParcels&searchTerm=' + encodeURIComponent(searchTerm) + '&sessid=' + BX.bitrix_sessid())
                .then(response => {
                    if (!response.ok) {
                        throw new Error(BX.message('ERROR_RESPONSE'));
                    }
                    return response.json();
                })
                .then(data => {
                    console.log(data)

                    if (data.status === 'success') {
                        data.data.forEach(name => {
                            const option = document.createElement('option');
                            option.value = name;
                            dataList.appendChild(option);
                        });
                    } else if (data.errors[0].message === BX.message('POINTS_UPDATE_IN_PROCESS')) {
                        alert(data.errors[0].message);
                    } else {
                        console.log(data.errors[0].message);
                    }
                })
                .catch(error => {
                    console.error(BX.message('ERROR_RESPONSE') + ':', error);
                });
        }
    });
}
