<?php

namespace Boxberry\Api;

use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);

class CountriesSettings
{
    public const LOAD_LIMIT = 31000;
    public const MAX_LENGTH_SIDE = 120;
    public const MAX_SUM_ALL_SIDES = 250;
    public const MAX_WEIGHT_OVERSIZED = 15000;
    public const MAX_LENGTH_OVERSIZED = 185;
    public const COD_AVAILABLE_COUNTRIES = ['643', '398'];
    public static function getCodeByName($countryName): ?string
    {
        return self::getCountries()[$countryName] ?? null;
    }

    public static function getCountries(): array
    {
        return [
            Loc::getMessage('RUSSIA') => '643',
            Loc::getMessage('KAZAKHSTAN') => '398',
            Loc::getMessage('BELARUS') => '112',
            Loc::getMessage('KYRGYZSTAN') => '417',
            Loc::getMessage('ARMENIA') => '051',
            Loc::getMessage('TAJIKISTAN') => '762',
            Loc::getMessage('UZBEKISTAN') => '860',
        ];
    }
}