<?php

namespace Boxberry\Api\Entity;

use Bitrix\Main\Localization\Loc;
use Boxberry\Api\Exceptions\BoxberryApiException;

Loc::loadMessages(__FILE__);

class DadataResult
{

    private string $street;
    private string $house;
    private string $flat;

    /**
     * @throws BoxberryApiException
     */
    public function __construct($data)
    {
        if (empty($data)) {
            throw new BoxberryApiException(Loc::getMessage('DADATA_EMPTY_RESPONSE'));
        }

        if (isset($data['message'])) {
            throw new BoxberryApiException($data['message']);
        }

        if (!isset($data['suggestions'][0]['data']) || empty($data['suggestions'])) {
            throw new BoxberryApiException(Loc::getMessage('DADATA_SUGGESTIONS_EMPTY'));
        }

        $this->street = $data['suggestions'][0]['data']['street'] ?? '';
        $this->house = $data['suggestions'][0]['data']['house'] ?? '';
        $this->flat = $data['suggestions'][0]['data']['flat'] ?? '';
    }

    public function getStreet(): string
    {
        return $this->street;
    }

    public function setStreet(string $street): void
    {
        $this->street = $street;
    }

    public function getHouse(): string
    {
        return $this->house;
    }

    public function setHouse(string $house): void
    {
        $this->house = $house;
    }

    public function getFlat(): string
    {
        return $this->flat;
    }

    public function setFlat(string $flat): void
    {
        $this->flat = $flat;
    }

}