<?php

namespace Boxberry\Api\Entity;

class DeliveryCalculationParams
{
    const PICKUP_DELIVERY_TYPE_ID = 1;
    const COURIER_DELIVERY_TYPE_ID = 2;
    const ENABLE_SHOP_SETTINGS = 1;
    const DISABLE_SHOP_SETTINGS = 0;
    const MIN_INSURANCE_SUM = 5;
    const CALCULATE_API_METHOD_NAME = 'DeliveryCalculation';
    private string $targetStart = '';
    private string $recipientCityId = '';
    private string $deliveryType = '';
    private string $targetStop = '';
    private float $orderSum = 0;
    private float $paySum = 0;
    private string $zip = '';
    private int $weight = 0;
    private int $height = 0;
    private int $width = 0;
    private int $depth = 0;
    private array $boxSizes = [];
    private int $useShopSettings = 0;
    private string $cmsName = '';
    private string $version = '';
    private string $url = '';

    public function toArray(): array
    {
        return [
            'method' => self::CALCULATE_API_METHOD_NAME,
            'TargetStart' => $this->targetStart,
            'RecipientCityId' => $this->recipientCityId,
            'DeliveryType' => $this->deliveryType,
            'TargetStop' => $this->targetStop,
            'OrderSum' => $this->orderSum,
            'PaySum' => $this->paySum,
            'Zip' => $this->zip,
            'BoxSizes' => $this->boxSizes,
            'UseShopSettings' => $this->useShopSettings,
            'CmsName' => $this->cmsName,
            'Version' => $this->version,
            'Url' => $this->url,
        ];
    }

    public function getTargetStart(): string
    {
        return $this->targetStart;
    }

    public function setTargetStart(string $targetStart): void
    {
        $this->targetStart = $targetStart;
    }

    public function getRecipientCityId(): string
    {
        return $this->recipientCityId;
    }

    public function setRecipientCityId(string $recipientCityId): void
    {
        $this->recipientCityId = $recipientCityId;
    }

    public function getDeliveryType(): string
    {
        return $this->deliveryType;
    }

    public function setDeliveryType(string $deliveryType): void
    {
        $this->deliveryType = $deliveryType;
    }

    public function getTargetStop(): string
    {
        return $this->targetStop;
    }

    public function setTargetStop(string $targetStop): void
    {
        $this->targetStop = $targetStop;
    }

    public function getOrderSum(): float
    {
        return $this->orderSum;
    }

    public function setOrderSum(float $orderSum): void
    {
        $this->orderSum = $orderSum;
    }

    public function getPaySum(): float
    {
        return $this->paySum;
    }

    public function setPaySum(float $paySum): void
    {
        $this->paySum = $paySum;
    }

    public function getZip(): string
    {
        return $this->zip;
    }

    public function setZip(string $zip): void
    {
        $this->zip = $zip;
    }

    public function getWeight(): int
    {
        return $this->weight;
    }

    public function setWeight(int $weight): void
    {
        $this->weight = $weight;
    }

    public function getHeight(): int
    {
        return $this->height;
    }

    public function setHeight(int $height): void
    {
        $this->height = $height;
    }

    public function getWidth(): int
    {
        return $this->width;
    }

    public function setWidth(?int $width): void
    {
        $this->width = $width;
    }

    public function getDepth(): int
    {
        return $this->depth;
    }

    public function setDepth(int $depth): void
    {
        $this->depth = $depth;
    }

    public function getBoxSizes(): array
    {
        return $this->boxSizes;
    }

    public function setBoxSizes(array $boxes): void
    {
        $this->boxSizes = $boxes;
    }

    public function getUseShopSettings(): int
    {
        return $this->useShopSettings;
    }

    public function setUseShopSettings(int $useShopSettings): void
    {
        $this->useShopSettings = $useShopSettings;
    }

    public function getCmsName(): string
    {
        return $this->cmsName;
    }

    public function setCmsName(string $cmsName): void
    {
        $this->cmsName = $cmsName;
    }

    public function getVersion(): string
    {
        return $this->version;
    }

    public function setVersion(?string $version): void
    {
        $this->version = $version;
    }

    public function getUrl(): string
    {
        return $this->url;
    }

    public function setUrl(string $url): void
    {
        $this->url = $url;
    }

}