<?php

namespace Boxberry\Api\Entity;

use Boxberry\Api\Exceptions\BoxberryApiException;
use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);
class GetKeyIntegration
{
    private string $key;

    /**
     * @throws BoxberryApiException
     */
    public function __construct($data)
    {
        if (empty($data)) {
            throw new BoxberryApiException(Loc::getMessage('EMPTY_RESULT_FROM_GET_KEY_INTEGRATION'));
        }

        if (isset($data['err'])) {
            throw new BoxberryApiException($data['err']);
        }

        if (isset($data['error'])) {
            throw new BoxberryApiException($data['error']);
        }

        $this->key = $data['key'];


    }

    public function getKey(): string
    {
        return $this->key;
    }

}