<?php

namespace Boxberry\Api\Entity;

use Boxberry\Api\Exceptions\BoxberryApiException;
use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);
class GetLastStatusData
{
    /**
     * @throws BoxberryApiException
     */
    public function __construct(
        private array $trackingData
    ) {
        if (empty($this->trackingData)) {
            throw new BoxberryApiException(Loc::getMessage('EMPTY_RESULT_FROM_GET_LAST_STATUS_DATA'));
        }

        if (isset($this->trackingData['err'])) {
            throw new BoxberryApiException($this->trackingData['err']);
        }

        if (isset($this->trackingData['error'])) {
            throw new BoxberryApiException($this->trackingData['error']);
        }
    }

    public function getAllTrackingData(): array
    {
        return $this->trackingData;
    }

    public function getDataByTrack($trackNumber): mixed
    {
        return $this->trackingData[$trackNumber] ?? [];
    }

    public function getLastStatusIdByTrack($trackNumber): mixed
    {
        return $this->trackingData[$trackNumber]['lastStatusId'] ?? '';
    }

    public function getLastStatusNameByTrack($trackNumber): mixed
    {
        return $this->trackingData[$trackNumber]['lastStatusName'] ?? '';
    }

    public function getLastStatusDateByTrack($trackNumber): mixed
    {
        return $this->trackingData[$trackNumber]['lastStatusDate'] ?? '';
    }

    public function getLastStatusStoreDateByTrack($trackNumber): mixed
    {
        return $this->trackingData[$trackNumber]['storeDate'] ?? '';
    }

    public function getLastStatusDeliveryDateByTrack($trackNumber): mixed
    {
        return $this->trackingData[$trackNumber]['deliveryDate'] ?? '';
    }
}