<?php

namespace Boxberry\Api\Entity;

use Boxberry\Api\Exceptions\BoxberryApiException;
use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);

class ParcelResult
{
    private string $track = '';
    private string $notification = '';
    private string $label = '';

    /**
     * @throws BoxberryApiException
     */
    public function __construct($data)
    {
        if (empty($data)) {
            throw new BoxberryApiException(Loc::getMessage('EMPTY_RESULT_FROM_PARSEL_CREATE'));
        }

        if (isset($data['err'])) {
            throw new BoxberryApiException($data['err']);
        }

        if (isset($data['error'])) {
            throw new BoxberryApiException($data['error']);
        }

        $this->track = $data['track'];
        $this->notification = $data['notification'] ?? '';
        $this->label = $data['label'];

    }

    public function getTrack(): string
    {
        return $this->track;
    }

    public function setTrack(string $track): void
    {
        $this->track = $track;
    }

    public function getNotification(): string
    {
        return $this->notification;
    }

    public function setNotification(string $notification): void
    {
        $this->notification = $notification;
    }

    public function getLabel(): string
    {
        return $this->label;
    }

    public function setLabel(string $label): void
    {
        $this->label = $label;
    }

}