<?php

namespace Boxberry\Api\Entity;

use Boxberry\Api\Exceptions\BoxberryApiException;
use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);

class ParselSendResult
{
    private string $id;
    private string $label;
    private string $urlTmc;
    private string $sticker;

    /**
     * @throws BoxberryApiException
     */
    public function __construct($data = null)
    {
        if (empty($data)) {
            throw new BoxberryApiException(Loc::getMessage('EMPTY_RESULT_FROM_PARSEL_SEND'));
        }

        if (isset($data['err'])) {
            throw new BoxberryApiException($data['err']);
        }

        $this->id = $data['id'];
        $this->label = $data['label'];
        $this->sticker = $data['sticker'];

        if (isset($data['url_tmc'])) {
            $this->urlTmc = $data['url_tmc'];
        }
    }

    public function getId(): string
    {
        return $this->id;
    }

    public function setId(string $id): void
    {
        $this->id = $id;
    }

    public function getLabel(): string
    {
        return $this->label;
    }

    public function setLabel(string $label): void
    {
        $this->label = $label;
    }

    public function getUrlTmc(): string
    {
        return $this->urlTmc;
    }

    public function setUrlTmc(string $urlTmc): void
    {
        $this->urlTmc = $urlTmc;
    }

    public function getSticker(): string
    {
        return $this->sticker;
    }

    public function setSticker(string $sticker): void
    {
        $this->sticker = $sticker;
    }
}