<?php

namespace Boxberry\Api\Entity;

use Boxberry\Api\Exceptions\BoxberryApiException;
use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);

class PointsDescriptionResult
{
    private string $address;
    private string $cityName;
    private string $area;
    private string $street;
    private string $house;
    private string $apartment;
    private string $cityCode;
    private string $countryCode;

    /**
     * @throws BoxberryApiException
     */
    public function __construct(array $data)
    {
        if (isset($data['err'])) {
            throw new BoxberryApiException($data['err']);
        }

        if (isset($data['error'])) {
            throw new BoxberryApiException($data['error']);
        }

        if (empty($data)) {
            throw new BoxberryApiException(Loc::getMessage('EMPTY_RESULT_FROM_POINTS_DESCRIPTION'));
        }

        $this->address = $data['Address'];
        $this->cityName = $data['CityName'];
        $this->area = $data['Area'];
        $this->street = $data['Street'];
        $this->house = $data['House'];
        $this->apartment = $data['Apartment'];
        $this->cityCode = $data['CityCode'];
        $this->countryCode = $data['CountryCode'];
    }

    public function getAddress(): string
    {
        return $this->address;
    }

    public function setAddress(string $address): void
    {
        $this->address = $address;
    }

    public function getCityName(): string
    {
        return $this->cityName;
    }

    public function setCityName(string $cityName): void
    {
        $this->cityName = $cityName;
    }

    public function getStreet(): string
    {
        return $this->street;
    }

    public function setStreet(string $street): void
    {
        $this->street = $street;
    }

    public function getHouse(): string
    {
        return $this->house;
    }

    public function setHouse(string $house): void
    {
        $this->house = $house;
    }

    public function getCityCode(): string
    {
        return $this->cityCode;
    }

    public function setCityCode(string $cityCode): void
    {
        $this->cityCode = $cityCode;
    }

    public function getCountryCode(): string
    {
        return $this->countryCode;
    }

    public function setCountryCode(string $countryCode): void
    {
        $this->countryCode = $countryCode;
    }

    public function getArea(): string
    {
        return $this->area;
    }

    public function setArea(string $area): void
    {
        $this->area = $area;
    }

    public function getApartment(): string
    {
        return $this->apartment;
    }

    public function setApartment(string $apartment): void
    {
        $this->apartment = $apartment;
    }

}