<?php

namespace Boxberry\Api\Entity;

use Boxberry\Api\Exceptions\BoxberryApiException;
use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);

class ZipCheck
{
    private int $expressDelivery;
    private string $zoneExpressDelivery;
    private int $remoteness;

    /**
     * @throws BoxberryApiException
     */
    public function __construct($data)
    {
        if (empty($data)) {
            throw new BoxberryApiException(Loc::getMessage('EMPTY_RESULT_FROM_ZIP_CHECK'));
        }

        if (isset($data['err'])) {
            throw new BoxberryApiException($data['err']);
        }

        if (isset($data['error'])) {
            throw new BoxberryApiException($data['error']);
        }

        $this->expressDelivery = $data[0]['ExpressDelivery'];
        $this->zoneExpressDelivery = $data[0]['ZoneExpressDelivery'];
        $this->remoteness = $data[0]['Remoteness'];
    }

    public function getExpressDelivery(): int
    {
        return $this->expressDelivery;
    }

    public function setExpressDelivery(int $expressDelivery): void
    {
        $this->expressDelivery = $expressDelivery;
    }

    public function getZoneExpressDelivery(): string
    {
        return $this->zoneExpressDelivery;
    }

    public function setZoneExpressDelivery(string $zoneExpressDelivery): void
    {
        $this->zoneExpressDelivery = $zoneExpressDelivery;
    }

    public function getRemoteness(): int
    {
        return $this->remoteness;
    }

    public function setRemoteness(int $remoteness): void
    {
        $this->remoteness = $remoteness;
    }

    public function isExpressDelivery(): bool
    {
        return $this->expressDelivery === 1;
    }


}