<?php

namespace Boxberry\Bitrix\Entity;

use Bitrix\Main\Text\StringHelper;
use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);

class City
{
    private string $code;
    private string $name;
    private string $reception;
    private string $pickupPoint;
    private string $foreignReceptionReturns;
    private string $terminal;
    private string $courierDelivery;
    private string $kladr;
    private string $region;
    private string $countryCode;
    private string $uniqName;
    private string $district;
    private string $prefix;
    private string $courierReception;

    /**
     * @throws \Exception
     */
    public function __construct($data)
    {
        if (!isset($data['CODE'])) {
            throw new \Exception(Loc::getMessage('ERROR_CITY_CODE_NOT_FOUND'));
        }

        foreach ($data as $key => $value) {
            $key = lcfirst(StringHelper::snake2camel($key));

            if (property_exists($this, $key)) {
                $this->$key = $value;
            }
        }

    }

    public function getCode(): string
    {
        return $this->code;
    }

    public function setCode(string $code): void
    {
        $this->code = $code;
    }

    public function getName(): string
    {
        return $this->name;
    }

    public function setName(string $name): void
    {
        $this->name = $name;
    }

    public function getReception(): string
    {
        return $this->reception;
    }

    public function setReception(string $reception): void
    {
        $this->reception = $reception;
    }

    public function getPickupPoint(): string
    {
        return $this->pickupPoint;
    }

    public function setPickupPoint(string $pickupPoint): void
    {
        $this->pickupPoint = $pickupPoint;
    }

    public function getForeignReceptionReturns(): string
    {
        return $this->foreignReceptionReturns;
    }

    public function setForeignReceptionReturns(string $foreignReceptionReturns): void
    {
        $this->foreignReceptionReturns = $foreignReceptionReturns;
    }

    public function getTerminal(): string
    {
        return $this->terminal;
    }

    public function setTerminal(string $terminal): void
    {
        $this->terminal = $terminal;
    }

    public function getCourierDelivery(): string
    {
        return $this->courierDelivery;
    }

    public function setCourierDelivery(string $courierDelivery): void
    {
        $this->courierDelivery = $courierDelivery;
    }

    public function getKladr(): string
    {
        return $this->kladr;
    }

    public function setKladr(string $kladr): void
    {
        $this->kladr = $kladr;
    }

    public function getRegion(): string
    {
        return $this->region;
    }

    public function setRegion(string $region): void
    {
        $this->region = $region;
    }

    public function getCountryCode(): string
    {
        return $this->countryCode;
    }

    public function setCountryCode(string $countryCode): void
    {
        $this->countryCode = $countryCode;
    }

    public function getUniqName(): string
    {
        return $this->uniqName;
    }

    public function setUniqName(string $uniqName): void
    {
        $this->uniqName = $uniqName;
    }

    public function getDistrict(): string
    {
        return $this->district;
    }

    public function setDistrict(string $district): void
    {
        $this->district = $district;
    }

    public function getPrefix(): string
    {
        return $this->prefix;
    }

    public function setPrefix(string $prefix): void
    {
        $this->prefix = $prefix;
    }

    public function getCourierReception(): string
    {
        return $this->courierReception;
    }

    public function setCourierReception(string $courierReception): void
    {
        $this->courierReception = $courierReception;
    }
}