<?php

namespace Boxberry\Bitrix\Helpers;

class BoxSizes
{
    private int $width = 0;
    private int $height = 0;
    private int $depth = 0;
    private int $weight = 0;
    private int $quantity = 0;
    private array $items = [];
    private array $boxSizesArray = [];

    public function setWidth(int $width): void
    {
        $this->width = $width;
    }

    public function getWidth(): int
    {
        return $this->width;
    }

    public function setHeight(int $height): void
    {
        $this->height = $height;
    }

    public function getHeight(): int
    {
        return $this->height;
    }

    public function setDepth(int $depth): void
    {
        $this->depth = $depth;
    }

    public function getDepth(): int
    {
        return $this->depth;
    }

    public function setWeight(int $weight): void
    {
        $this->weight = $weight;
    }

    public function getWeight(): int
    {
        return $this->weight;
    }

    public function setQuantity(int $quantity): void
    {
        $this->quantity = $quantity;
    }

    public function getQuantity(): int
    {
        return $this->quantity;
    }

    public function addItem(int $id, string $name, float $price, int $quantity): void
    {
        $this->items[] = [
            'id'       => $id,
            'name'     => $name,
            'price'    => $price,
            'quantity' => $quantity
        ];
    }

    public function getItems(): array
    {
        return $this->items;
    }

    public function clearItems(): void
    {
        $this->items = [];
    }

    public function getLengthSide(int $x, int $y, int $z): int
    {
        $oldBoxVolume = $this->getWidth() * $this->getHeight() * $this->getDepth();
        $newBoxVolume = $oldBoxVolume + ($x * $y * $z);
        return $newBoxVolume ** (1 / 3);
    }

    public function addBox(int $width, int $height, int $depth, int $weight): void
    {
        $boxParams = [
            'Width'  => $width,
            'Height' => $height,
            'Depth'  => $depth,
            'Weight' => $weight,
        ];

        if ($items = $this->getItems()) {
            $boxParams['Items'] = $items;
        }

        $this->boxSizesArray[] = $boxParams;
    }

    public function getBoxSizesArray(): array
    {
        return $this->boxSizesArray;
    }
}