<?php

namespace Boxberry\Bitrix\Helpers;

use Bitrix\Main\Diag\FileLogger;

class Logger extends FileLogger
{
    public static function Add($auditTypeId, $itemId, $description = ''): void
    {
        if ($description instanceof \Exception) {
            $description = $description->getMessage() . ' | ' . $description->getFile() . ' | ' . $description->getLine();
        }  elseif (is_string($description) && mb_strlen($auditTypeId) > 50) {
            $description = $auditTypeId . (!empty($description) ? ' | ' . $description : '');
        }

        \CEventLog::Add([
            'SEVERITY' => \CEventLog::SEVERITY_ERROR,
            'AUDIT_TYPE_ID' => $auditTypeId,
            'MODULE_ID' => BB_MODULE_ID,
            'ITEM_ID' => $itemId,
            'DESCRIPTION' => $description,
        ]);
    }

    protected function rotateLog()
    {
    }


}