<?php

namespace Boxberry\Bitrix\Helpers;

use Bitrix\Sale\Delivery\Services\Table;
use Bitrix\Sale\Order;

class Validator
{
    public static function isBoxberryDeliveryInOrder(Order $order): bool
    {
        try {
            if (!$deliveryIdList = $order->getDeliveryIdList()) {
                return false;
            }
        } catch (\Exception $e) {
            return false;
        }

        foreach ($deliveryIdList as $deliveryId) {
            if (self::isBoxberryDelivery($deliveryId)) {
                return true;
            }
        }

        return false;

    }

    private static function isBoxberryDelivery($deliveryId): bool
    {
        try {
            $deliveryService = Table::query()
                ->addSelect('ID')
                ->where('ID', $deliveryId)
                ->where('CLASS_NAME', Delivery::BB_PROFILE_CLASS_NAME)
                ->setLimit(1)
                ->exec()
                ->fetch();
        } catch (\Exception $e) {
            return false;
        }

        return (bool)$deliveryService;
    }

}