<?php

namespace Boxberry\Delivery\Controllers;

use Bitrix\Main\Engine\Controller;
use Bitrix\Main\Engine\Response\AjaxJson;
use Bitrix\Main\ErrorCollection;
use Boxberry\Api\Client;
use Boxberry\Bitrix\Services\Updater;
use Bitrix\Main\Engine\ActionFilter;

class Settings extends Controller
{
    public function checkModuleUpdateAction(): AjaxJson
    {
        $result = Client::checkModuleUpdate();

        if ($result->isSuccess()) {
            return AjaxJson::createSuccess($result->getData());
        } else {
           return AjaxJson::createError(new ErrorCollection($result->getErrors()));
        }
    }

    public function updateAction(string $url, string $version, string $archiveFormat): AjaxJson
    {
        $result = Updater::execute($url, $version, $archiveFormat);

        if ($result->isSuccess()) {
            return AjaxJson::createSuccess($result->getData());
        } else {
            return AjaxJson::createError(new ErrorCollection($result->getErrors()));
        }
    }

    protected function getDefaultPreFilters(): array
    {

        return array_merge(
            parent::getDefaultPreFilters(),
            [
                new ActionFilter\Cors(),
                new ActionFilter\Scope(ActionFilter\Scope::AJAX),
            ]
        );
    }
}