<?php

use Bitrix\Main\Loader;
use Boxberry\Bitrix\Helpers\Extensions;
use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);

global $APPLICATION;
$module_id = 'boxberry.delivery';
Loader::includeModule($module_id);
Extensions::initSettings();

function getTabs(): array
{
    return [
        [
            'DIV' => 'general',
            'TAB' => Loc::getMessage('GENERAL_TAB_NAME'),
            'ICON' => '',
            'TITLE' => Loc::getMessage('GENERAL_TAB_TITLE')
        ],
        [
            'DIV' => 'statuses',
            'TAB' => Loc::getMessage('STATUSES_TAB_NAME'),
            'ICON' => '',
            'TITLE' => Loc::getMessage('STATUSES_TAB_TITLE')
        ],
        [
            'DIV' => 'debug',
            'TAB' => Loc::getMessage('DEBUG_TAB_NAME'),
            'ICON' => '',
            'TITLE' => Loc::getMessage('DEBUG_TAB_TITLE')
        ],
        [
            'DIV' => 'group_rights',
            'TAB' => Loc::getMessage('MAIN_TAB_RIGHTS'),
            'TITLE' => Loc::getMessage('MAIN_TAB_TITLE_RIGHTS')
        ],
        [
            'DIV' => 'update',
            'TAB' => Loc::getMessage('MODULE_UPDATE_TAB_NAME'),
            'ICON' => '',
            'TITLE' => Loc::getMessage('MODULE_UPDATE_TAB_TITLE')
        ],
        [
            'DIV' => 'services',
            'TAB' => Loc::getMessage('MODULE_SERVICES_TAB_NAME'),
            'ICON' => '',
            'TITLE' => Loc::getMessage('MODULE_SERVICES_TAB_TITLE')
        ]
    ];
}

$arTabs = getTabs();

$tabControl = new CAdminTabControl("tabControl", $arTabs);
?>
<form name="<?= $module_id ?>" method="POST"
      action="<?= $APPLICATION->GetCurPage() ?>?mid=<?= $module_id ?>&lang=<?= LANGUAGE_ID ?>"
      enctype="multipart/form-data">
    <?php echo bitrix_sessid_post(); ?>

    <?php $tabControl->Begin();

    $tabControl->BeginNextTab();
    include_once($_SERVER['DOCUMENT_ROOT'] . "/bitrix/modules/" . $module_id . "/options/general.php");
    $tabControl->BeginNextTab();
    include_once($_SERVER['DOCUMENT_ROOT'] . "/bitrix/modules/" . $module_id . "/options/statuses.php");
    $tabControl->BeginNextTab();
    include_once($_SERVER['DOCUMENT_ROOT'] . "/bitrix/modules/" . $module_id . "/options/debug.php");
    $tabControl->BeginNextTab();
    include_once($_SERVER['DOCUMENT_ROOT'] . "/bitrix/modules/" . $module_id . "/options/group_rights.php");
    $tabControl->BeginNextTab();
    include_once($_SERVER['DOCUMENT_ROOT'] . "/bitrix/modules/" . $module_id . "/options/update.php");
    $tabControl->BeginNextTab();
    include_once($_SERVER['DOCUMENT_ROOT'] . "/bitrix/modules/" . $module_id . "/options/services.php");

    $tabControl->Buttons([]); ?>
    <input type="hidden" name="Update" value="Y">
    <?php $tabControl->End(); ?>

</form>
