<?php

use \Bitrix\Main\Config\Option;
use Bitrix\Main\Context;
use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);

$request = Context::getCurrent()->getRequest();
$postList = $request->getPostList();

if ($request->isAdminSection() && ($postList->get('save') || $postList->get('apply'))) {

    Option::set(BB_MODULE_ID, "EVENT_LOG_ENABLE", $postList->get('EVENT_LOG_ENABLE'));
    Option::set(BB_MODULE_ID, "CONSOLE_LOG_ENABLE", $postList->get('CONSOLE_LOG_ENABLE'));
    Option::set(BB_MODULE_ID, "API_LOG_ENABLE", $postList->get('API_LOG_ENABLE'));
    Option::set(BB_MODULE_ID, "API_LOG_FILE_SIZE", $postList->get('API_LOG_FILE_SIZE'));
    Option::set(BB_MODULE_ID, "API_LOG_FILE_PATH", $postList->get('API_LOG_FILE_PATH'));
}

?>
<tr class="heading">
    <td colspan="2"><?php echo Loc::getMessage('DEBUG_OPTIONS_HEADER_NAME')?></td>
</tr>
<tr>
    <td style="width: 50%;" class="adm-detail-content-cell-l"><?php echo Loc::getMessage('DEBUG_OPTIONS_EVENT_LOG_ENABLE')?></td>
    <td style="width: 50%;" class="adm-detail-content-cell-r">
        <input type="hidden" name="EVENT_LOG_ENABLE" value="N">
        <label for="event_log_enable"></label><input type="checkbox" value="Y" name="EVENT_LOG_ENABLE"
                                                     id="event_log_enable" <?php echo (Option::get(BB_MODULE_ID, "EVENT_LOG_ENABLE", "N") == 'Y') ? 'checked = "checked"' : '' ?>>
    </td>
</tr>
<tr>
    <td style="width: 50%;" class="adm-detail-content-cell-l"><?php echo Loc::getMessage('DEBUG_OPTIONS_CONSOLE_LOG_ENABLE')?></td>
    <td style="width: 50%;" class="adm-detail-content-cell-r">
        <input type="hidden" name="CONSOLE_LOG_ENABLE" value="N">
        <label for="console_log_enable"></label><input type="checkbox" value="Y" name="CONSOLE_LOG_ENABLE"
                                                     id="console_log_enable" <?php echo (Option::get(BB_MODULE_ID, "CONSOLE_LOG_ENABLE", "N") == 'Y') ? 'checked = "checked"' : '' ?>>
        <span data-hint="<?php echo Loc::getMessage('DEBUG_OPTIONS_CONSOLE_LOG_ENABLE_HINT')?>"></span>
    </td>
</tr>
<tr class="heading">
    <td colspan="2"><?php echo Loc::getMessage('DEBUG_OPTIONS_API_LOGGING_HEADER_NAME')?></td>
</tr>
<tr>
    <td style="width: 50%;" class="adm-detail-content-cell-l"><?php echo Loc::getMessage('DEBUG_OPTIONS_API_LOG_ENABLE')?></td>
    <td style="width: 50%;" class="adm-detail-content-cell-r">
        <input type="hidden" name="API_LOG_ENABLE" value="N">
        <label for="api_log_enable"></label><input type="checkbox" value="Y" name="API_LOG_ENABLE"
                                                       id="api_log_enable" <?php echo (Option::get(BB_MODULE_ID, "API_LOG_ENABLE", "N") == 'Y') ? 'checked = "checked"' : '' ?>>
    </td>
</tr>
<tr>
    <td style="width: 50%;" class="adm-detail-content-cell-l"><?php echo Loc::getMessage('DEBUG_OPTIONS_API_LOG_FILE_SIZE')?></td>
    <td style="width: 50%;" class="adm-detail-content-cell-r">
        <label>
            <input type="text" name="API_LOG_FILE_SIZE" id="api_log_file_size" size="10" value="<?php echo Option::get(BB_MODULE_ID, "API_LOG_FILE_SIZE", '2')?>">
        </label>
    </td>
</tr>
<tr>
    <td style="width: 50%;" class="adm-detail-content-cell-l"><?php echo Loc::getMessage('DEBUG_OPTIONS_API_LOG_FILE_PATH')?></td>
    <td style="width: 50%;" class="adm-detail-content-cell-r">
        <label>
            <input type="text" name="API_LOG_FILE_PATH" id="api_log_file_path" size="30" value="<?php echo Option::get(BB_MODULE_ID, "API_LOG_FILE_PATH", '/bitrix/modules/boxberry.delivery/api.log')?>">
        </label>
        <span data-hint="<?php echo Loc::getMessage('DEBUG_OPTIONS_API_LOG_FILE_PATH_HINT')?>"></span>
    </td>
</tr>