<?php

use Bitrix\Main\Config\Option;
use Bitrix\Main\Context;
use Boxberry\Bitrix\Helpers\Options;
use Bitrix\Main\Localization\Loc;

Loc::loadMessages(__FILE__);

$request = Context::getCurrent()->getRequest();
$postList = $request->getPostList();

if ($request->isAdminSection() && ($postList->get('save') || $postList->get('apply'))) {

    Option::set(BB_MODULE_ID, "ARTNUMBER_PROP_CODE", $postList->get('ARTNUMBER_PROP_CODE'));
    Option::set(BB_MODULE_ID, "CREATE_ORDER_ADMIN_FOR_ALL", $postList->get('CREATE_ORDER_ADMIN_FOR_ALL'));
    Option::set(BB_MODULE_ID, "SET_DELIVERY_TO_ORDER", $postList->get('SET_DELIVERY_TO_ORDER'));
    Option::set(BB_MODULE_ID, "ORDER_STATUS_FOR_EXPORT", $postList->get('ORDER_STATUS_FOR_EXPORT'));
    Option::set(BB_MODULE_ID, "SET_TRACK_TO_SHIPMENT", $postList->get('SET_TRACK_TO_SHIPMENT'));
    Option::set(BB_MODULE_ID, "INIT_WIDGET_ONLY_ON_STANDARD_EVENT", $postList->get('INIT_WIDGET_ONLY_ON_STANDARD_EVENT'));
}

$articleDefaultPropertyCode = Options::isProductPropExist('ARTNUMBER') ? 'ARTNUMBER' : '';
$bitrixOrderStatuses = Options::getBitrixOrderStatuses();

?>
<tr class="heading">
    <td colspan="2"><?php echo Loc::getMessage('ITEM_ARTNUMBER')?></td>
</tr>
<tr>
    <td style="width: 50%;" class="adm-detail-content-cell-l"><?php echo Loc::getMessage('ARTNUMBER_OPTION_DESCRIPTION')?></td>
    <td style="width: 50%;" class="adm-detail-content-cell-r">
        <label>
            <input type="text" name="ARTNUMBER_PROP_CODE" id="artnumber_prop_code" size="10" value="<?php echo Option::get(BB_MODULE_ID, "ARTNUMBER_PROP_CODE", $articleDefaultPropertyCode)?>">
        </label><span data-hint="<?php echo Loc::getMessage('ARTNUMBER_PROP_CODE_HINT')?>"></span>
    </td>
</tr>
<tr class="heading">
    <td colspan="2"><?php echo Loc::getMessage('CREATE_ORDER_ADMIN_MANUAL_OPTIONS_HEADER_NAME')?></td>
</tr>
<tr>
    <td style="width: 50%;" class="adm-detail-content-cell-l"><?php echo Loc::getMessage('CREATE_ORDER_ADMIN_FOR_ALL_OPTION_DESCRIPTION')?></td>
    <td style="width: 50%;" class="adm-detail-content-cell-r">
        <input type="hidden" name="CREATE_ORDER_ADMIN_FOR_ALL" value="N">
        <label for="create_order_admin_for_all"></label><input type="checkbox" value="Y" name="CREATE_ORDER_ADMIN_FOR_ALL" id="create_order_admin_for_all" class="" <?php echo  (Option::get(BB_MODULE_ID, "CREATE_ORDER_ADMIN_FOR_ALL", "Y") == 'Y')? 'checked = "checked"' : ''?>>
        <span data-hint="<?php echo Loc::getMessage('CREATE_ORDER_ADMIN_FOR_ALL_HINT')?>"></span>
    </td>
</tr>
<tr class="heading">
    <td colspan="2"><?php echo Loc::getMessage('CREATE_ORDER_AUTO_OPTIONS_HEADER_NAME')?></td>
</tr>
<tr>
    <td style="width: 50%;" class="adm-detail-content-cell-l"><?php echo Loc::getMessage('ORDER_STATUS_FOR_EXPORT_OPTION_DESCRIPTION')?></td>
    <td style="width: 50%;" class="adm-detail-content-cell-r">
        <label for="order_status_for_export"></label><select name="ORDER_STATUS_FOR_EXPORT" id="order_status_for_export">
            <option value=""><?php echo Loc::getMessage('NOT_SELECTED_VALUE')?></option>
            <?php
            $currentOrderStatusForExport = Option::get(BB_MODULE_ID, "ORDER_STATUS_FOR_EXPORT", '');
            foreach ($bitrixOrderStatuses as $statusId => $statusName): ?>
                <option value="<?php echo $statusId; ?>" <?php echo ($currentOrderStatusForExport == $statusId) ? 'selected' : ''; ?>>
                    <?php echo $statusName; ?>
                </option>
            <?php endforeach; ?>
        </select>
    </td>
</tr>
<tr>
    <td style="width: 50%;" class="adm-detail-content-cell-l"><?php echo Loc::getMessage('SET_TRACK_TO_SHIPMENT_OPTION_DESCRIPTION')?></td>
    <td style="width: 50%;" class="adm-detail-content-cell-r">
        <input type="hidden" name="SET_TRACK_TO_SHIPMENT" value="N">
        <label for="set_track_to_shipment"></label><input type="checkbox" value="Y" name="SET_TRACK_TO_SHIPMENT" id="set_track_to_shipment" class="" <?php echo  (Option::get(BB_MODULE_ID, "SET_TRACK_TO_SHIPMENT", "Y") == 'Y')? 'checked = "checked"' : ''?>>
    </td>
</tr>
<tr class="heading">
    <td colspan="2"><?php echo Loc::getMessage('INIT_WIDGET_SETTINGS_HEADER_NAME')?></td>
</tr>
<tr>
    <td style="width: 50%" class="adm-detail-content-cell-l"><?php echo Loc::getMessage('INIT_WIDGET_ONLY_ON_STANDARD_EVENT_OPTION_DESCRIPTION')?></td>
    <td style="width: 50%" class="adm-detail-content-cell-r">
        <input type="hidden" name="INIT_WIDGET_ONLY_ON_STANDARD_EVENT" value="N">
        <label for="init_widget_only_on_standard_event"></label><input type="checkbox" value="Y" name="INIT_WIDGET_ONLY_ON_STANDARD_EVENT" id="init_widget_only_on_standard_event" class="" <?php echo (Option::get(BB_MODULE_ID, "INIT_WIDGET_ONLY_ON_STANDARD_EVENT", "N") == 'Y') ? 'checked = "checked"' : ''?>>
        <span data-hint="<?php echo Loc::getMessage('INIT_WIDGET_ONLY_ON_STANDARD_EVENT_HINT')?>"></span>
    </td>
</tr>