<?php

use Bitrix\Main\Application;
use Bitrix\Main\IO\File;
use Bitrix\Main\ModuleManager;
use Bitrix\Main\IO\Directory;

/** @var CUpdater $updater */

if (ModuleManager::isModuleInstalled($updater->moduleID)) {

    //копирование файлов js и css
    if (version_compare(ModuleManager::getVersion($updater->moduleID), '1.0.20', '<')) {
        if (is_dir(dirname(__FILE__) . '/install/js')) {
            $updater->CopyFiles('install/js', 'js/' . $updater->moduleID . '/');
        }

        if (is_dir(dirname(__FILE__) . '/install/css')) {
            $updater->CopyFiles('install/css', 'css/' . $updater->moduleID . '/');
        }

        File::putFileContents(Application::getDocumentRoot() . '/bitrix/php_interface/include/sale_delivery/boxberry/handler.php', File::getFileContents(Application::getDocumentRoot() . '/bitrix/modules/' . $updater->moduleID . '/install/handler.php'));
    }

    if ($updater->TableExists('b_boxberry_city_codes')) {
        $updater->Query('DROP TABLE b_boxberry_city_codes');
    }

    $cityCodesTableFile = Application::getDocumentRoot() . '/bitrix/modules/' . $updater->moduleID . '/lib/boxberry/bitrix/CityCodesTable.php';

    if (File::isFileExists($cityCodesTableFile)) {
        File::deleteFile($cityCodesTableFile);
    }
}